//----------------------------------------------------------------------//
//HotQ																	//
//	Nbv{[h													//
//																		//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <tchar.h>
#include <memory>
#include <algorithm>
#include <RegularExpressions.hpp>
#include "usr_migemo.h"
#include "UIniFile.h"
#include "UserFunc.h"
#include "Unit1.h"
#include "ClipList.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

TClipBdList *ClipBdList = NULL;

//---------------------------------------------------------------------------
//f[^
//---------------------------------------------------------------------------
HistoryRec::HistoryRec(UnicodeString s)
{
	CreTime  = Now();

	Text = s;
	LineCount = count_lins(s);

	if (s.Length()>128) s = s.SubString(1, 128) + "...";
	s = ReplaceStr(s,"\r\n", "\n");
	s = ReplaceStr(s,"\r", "\n");
	ItemStr = s;
}

//---------------------------------------------------------------------------
// \[g֐(eLXg)
//---------------------------------------------------------------------------
int __fastcall HistCmp_Text(void * Item1, void * Item2)
{
	HistoryRec *hp1 = (HistoryRec *)Item1;
	HistoryRec *hp2 = (HistoryRec *)Item2;
	return CompareText(hp1->Text, hp2->Text);
}
//---------------------------------------------------------------------------
// \[g֐(ԏ)
//---------------------------------------------------------------------------
int __fastcall HistCmp_Time(void * Item1, void * Item2)
{
	HistoryRec *hp1 = (HistoryRec *)Item1;
	HistoryRec *hp2 = (HistoryRec *)Item2;
	if (hp1->CreTime == hp2->CreTime) return CompareText(hp1->Text, hp2->Text);
	return (hp1->CreTime < hp2->CreTime)? 1 : -1;
}
//---------------------------------------------------------------------------
// \[g֐(TCY)
//---------------------------------------------------------------------------
int __fastcall HistCmp_Length(void * Item1, void * Item2)
{
	HistoryRec *hp1 = (HistoryRec *)Item1;
	HistoryRec *hp2 = (HistoryRec *)Item2;
	if (hp1->Text.Length() == hp2->Text.Length()) return HistCmp_Text(Item1, Item2);
	return (hp2->Text.Length() - hp1->Text.Length());
}
//---------------------------------------------------------------------------
// \[g֐(s)
//---------------------------------------------------------------------------
int __fastcall HistCmp_LineCnt(void * Item1, void * Item2)
{
	HistoryRec *hp1 = (HistoryRec *)Item1;
	HistoryRec *hp2 = (HistoryRec *)Item2;
	if (hp1->LineCount == hp2->LineCount) return HistCmp_Length(Item1, Item2);
	return (hp2->LineCount - hp1->LineCount);
}

//---------------------------------------------------------------------------
//f[^Xg (TList p)
//---------------------------------------------------------------------------
__fastcall THistoryList::THistoryList(): TList()
{
}
//---------------------------------------------------------------------------
__fastcall THistoryList::~THistoryList()
{
	for (int i=0; i<Count; i++) delete Items[i];
}

//---------------------------------------------------------------------------
HistoryRec * __fastcall THistoryList::Get(int Index)
{
	return (HistoryRec *)(TList::Get(Index));
}
//---------------------------------------------------------------------------
void __fastcall THistoryList::Put(int Index, HistoryRec *Item)
{
	TList::Put(Index, Item);
}

//---------------------------------------------------------------------------
//t@Cɕۑ
//---------------------------------------------------------------------------
void __fastcall THistoryList::SaveToFile(UnicodeString fname)
{
	if (fname.IsEmpty()) return;

	std::unique_ptr<TStringList> fbuf(new TStringList());
	for (int i=0; i<Count; i++) {
		HistoryRec *hp = Items[i];
		fbuf->Add("CreTime=" + hp->CreTime.DateTimeString());
		fbuf->Add("LineCount=" + IntToStr(hp->LineCount));
		fbuf->Add(hp->Text);
		fbuf->Add(EmptyStr);
	}
	fbuf->SaveToFile(fname, TEncoding::UTF8);
}
//---------------------------------------------------------------------------
//t@CǍ
//---------------------------------------------------------------------------
void __fastcall THistoryList::LoadFromFile(UnicodeString fname)
{
	if (!FileExists(fname)) return;

	for (int i=0; i<Count; i++) delete Items[i];
	Clear();

	std::unique_ptr<TStringList> tbuf(new TStringList());
	std::unique_ptr<TStringList> fbuf(new TStringList());
	fbuf->LoadFromFile(fname);

	int l_count;
	TDateTime c_time;
	int lp	= 0;
	int stt = 0;

	for (int i=0; i<fbuf->Count; i++) {
		UnicodeString lbuf = fbuf->Strings[i];
		switch (stt) {
		case 0:
			if (StartsText("CreTime=", lbuf)) {
				c_time = TDateTime(get_tkn_r(lbuf, "="));
				stt++;
			}
			break;
		case 1:
			if (StartsText("LineCount=", lbuf)) {
				l_count = get_tkn_r(lbuf, "=").ToIntDef(0);
				if (l_count>0) {
					tbuf->Clear();
					lp = 0;
					stt++;
				}
				else {
					stt = 0;	//sȏ
				}
			}
			else {
				stt = 0;		//sȏ
			}
			break;
		case 2:
			tbuf->Add(lbuf);
			if (++lp == l_count) {
				HistoryRec *hp = new HistoryRec(tbuf->Text);
				hp->CreTime   = c_time;
				hp->LineCount = l_count;
				Add(hp);
				stt = 0;
			}
			break;
		}
	}
}

//---------------------------------------------------------------------------
//`()ݒ
//---------------------------------------------------------------------------
void __fastcall TClipBdList::RecyclePrc()
{
	Screen->Cursor = crHourGlass;
	Hide();

	UnicodeString sct = "ClipboardList";

	if (ClipLstFont) delete ClipLstFont;
	ClipLstFont = IniFile->ReadFontInf(sct, Font);
	if (ClipLstFont) {
		HistListBox->Font->Assign(ClipLstFont);
		TextListBox->Font->Assign(ClipLstFont);
		PreviewMemo->Font->Assign(ClipLstFont);
		PreviewMemo->Font->Size = IniFile->ReadInteger(sct, "FontSizeV", ClipLstFont->Size);
	}

	ClipDataFile = IniFile->ReadString(sct, "ClipDataFile", "CLIPDATA.txt");
	get_file_name_r(ClipDataFile);
	TextDataFile = IniFile->ReadString(sct, "TextDataFile", "TEXTDATA.txt");
	get_file_name_r(TextDataFile);

	SaveHistory  = IniFile->ReadBool(  sct, "SaveHistory");

	MaxCbItems	 = IniFile->ReadInteger(sct, "MaxItems", 	50);
	MaxTextLen	 = IniFile->ReadInteger(sct, "MaxTextLen",	0);
	MaxLineCnt	 = IniFile->ReadInteger(sct, "MaxLineCnt",	0);
	ShowLnCt	 = IniFile->ReadBool(   sct, "ShowLnCt");
	PreviewLn	 = IniFile->ReadInteger(sct, "PreviewLn",	0);

	int ta = IniFile->ReadInteger(sct, "Transparent", 255);
	if (ta>=0 && ta<255) {
		//
		AlphaBlend		= true;
		AlphaBlendValue = ta;
	}
	else {
		AlphaBlend		= false;
	}

	ClipHistList = new THistoryList();
	if (SaveHistory) ClipHistList->LoadFromFile(ClipDataFile);

	if (!FileExists(TextDataFile))
		SaveTextList();
	else
		TextListBox->Items->LoadFromFile(TextDataFile);

	//^t@CI{^
	int bcnt = 0;
	for (int i=0; i<MAX_TEXTDATABTN; i++) {
		UnicodeString fnam = IniFile->ReadString(sct, "TextDataBtn" + IntToStr(i + 1));
		if (!fnam.IsEmpty()) {
			get_file_name_r(fnam);
			bcnt++;
		}
		TextBtnFile[i] = fnam;
	}

	for (int i=0; i<TextDataBar->ButtonCount; i++) {
		TToolButton *bp = TextDataBar->Buttons[i];
		int idx 	= bp->Tag;
		bp->Enabled = FileExists(TextBtnFile[idx]);
		bp->Down	= (bp->Enabled && SameText(TextDataFile, TextBtnFile[idx]));
	}

	TextDataBar->Visible  = (bcnt>0);

	//OXg
	ExceptWordList->Clear();
	for (int i=1;;i++) {
		UnicodeString wd = IniFile->ReadString(sct, "ExceptWord" + IntToStr(i), EmptyStr);
		if (wd.IsEmpty()) break;
		ExceptWordList->Add(wd);
	}

	InitClipboardChain();

	Screen->Cursor = crDefault;
}

//---------------------------------------------------------------------------
__fastcall TClipBdList::TClipBdList(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TClipBdList::FormCreate(TObject *Sender)
{
	ClipLstFont = NULL;

	CbChained	 = false;
	ClipEnabled  = false;

	ExceptWordList = new TStringList();

	RecyclePrc();

	load_ComboBoxItems(FindComboBox, IniFile, "FindHistory", MAX_FINDHISTORY);
}

//---------------------------------------------------------------------------
void __fastcall TClipBdList::FormShow(TObject *Sender)
{
	//\t̂߂
	//炩ߌ݂̃tH[JX擾Ă
	hLastWnd	  = ::GetForegroundWindow();
	LastThreadID  = ::GetWindowThreadProcessId(hLastWnd, NULL);
	DWORD cur_tid = ::GetCurrentThreadId();
	if (::AttachThreadInput(cur_tid, LastThreadID, TRUE)) {
		hLastFocus = ::GetFocus();
		::AttachThreadInput(cur_tid, LastThreadID, FALSE);
	}
	else {
		hLastFocus = NULL;
	}

	UnicodeString sct = "ClipboardList";
	SetBounds(
		IniFile->ReadInteger(sct, "PosX",	0),
		IniFile->ReadInteger(sct, "PosY",	0),
		IniFile->ReadInteger(sct, "Width",	320),
		IniFile->ReadInteger(sct, "Height",	400));

	HistListBox->Font->Color = IniFile->ReadColor(sct, "FgColorL", clWindowText);
	HistListBox->Color		 = IniFile->ReadColor(sct, "BgColorL", clWindow);
	HistListBox->ItemHeight  = abs(HistListBox->Font->Height) + IniFile->ReadInteger(sct, "LineSpace", 0);

	PreviewMemo->Font->Color = IniFile->ReadColor(sct, "FgColorV", clWindowText);
	PreviewMemo->Color		 = IniFile->ReadColor(sct, "BgColorV", clWindow);
	PreviewMemo->Height		 = IniFile->ReadInteger(sct, "PreviewHeight", 50);

	TextListBox->Font->Color = IniFile->ReadColor(sct, "FgColorT", clWindowText);
	TextListBox->Color		 = IniFile->ReadColor(sct, "BgColorT", clWindow);
	TextListBox->ItemHeight  = abs(TextListBox->Font->Height) + IniFile->ReadInteger(sct, "LineSpace", 0);

	colCtrl  = IniFile->ReadColor(sct, "CtrlColor",  clGrayText);
	colLnCt  = IniFile->ReadColor(sct, "LnCtColor",  clWindowText);
	colSelBg = IniFile->ReadColor(sct, "SelBgColor", clHighlight);

	FindComboBox->Text = EmptyStr;
	MigemoCheckBox->Enabled = usr_Migemo->DictReady;
	MigemoCheckBox->Checked = usr_Migemo->DictReady && IniFile->ReadBool(sct, "Migemo");

	UpdateHistList();

	PageControl1Change(NULL);
}
//---------------------------------------------------------------------------
void __fastcall TClipBdList::FormHide(TObject *Sender)
{
	UnicodeString sct = "ClipboardList";
	IniFile->WriteInteger(sct, "PosX",		Left);
	IniFile->WriteInteger(sct, "PosY",		Top);
	IniFile->WriteInteger(sct, "Width",		Width);
	IniFile->WriteInteger(sct, "Height",	Height);
	IniFile->WriteInteger(sct, "PreviewHeight",	PreviewMemo->Height);
	IniFile->WriteBool(   sct, "Migemo",	MigemoCheckBox->Checked);

	save_ComboBoxItems(FindComboBox, IniFile, "FindHistory", MAX_FINDHISTORY);

	IniFile->UpdateFile();
}
//---------------------------------------------------------------------------
void __fastcall TClipBdList::FormDestroy(TObject *Sender)
{
	SaveHistList();

	if (CbChained) ::ChangeClipboardChain(Handle, hNextWnd);

	if (ClipLstFont) delete ClipLstFont;

	delete ClipHistList;
	delete ExceptWordList;
}

//---------------------------------------------------------------------------
void __fastcall TClipBdList::FormKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
	if (Key==VK_ESCAPE) Hide();
}

//---------------------------------------------------------------------------
//Nbv{[h̏
//---------------------------------------------------------------------------
void __fastcall TClipBdList::InitClipboardChain()
{
	UnicodeString sct = "ClipboardList";
	if (IniFile->ReadBool(sct, "Enable")) {
		if (!CbChained) hNextWnd = ::SetClipboardViewer(Handle);
		CbChained = ClipEnabled = true;
	}
	else {
		if (CbChained) ::ChangeClipboardChain(Handle, hNextWnd);
		CbChained = ClipEnabled = false;
	}
}

//---------------------------------------------------------------------------
// WM_CHANGECBCHAIN ̏
//---------------------------------------------------------------------------
void __fastcall TClipBdList::WmChangeCbChain(TMessage &msg)
{
	if(hNextWnd == (HWND)(msg.WParam)) hNextWnd = (HWND)(msg.LParam);
	msg.Result = ::SendMessage(hNextWnd, msg.Msg, msg.WParam, msg.LParam);
}
//---------------------------------------------------------------------------
// WM_DRAWCLIPBOARD ̏
//---------------------------------------------------------------------------
void __fastcall TClipBdList::WmDrawClipboard(TMessage &msg)
{
	AddHistList();
	msg.Result = ::SendMessage(hNextWnd, msg.Msg, msg.WParam, msg.LParam);
}
//---------------------------------------------------------------------------
//Alt+Key ̏
//---------------------------------------------------------------------------
void __fastcall TClipBdList::WmMenuChar(TMessage &msg)
{
	char key = (char)LOWORD(msg.WParam);
	if (key=='f')
		FindComboBox->SetFocus();
	else if (key=='l')
		HistListBox->SetFocus();

	msg.Result = (MNC_CLOSE << 16);
}


//---------------------------------------------------------------------------
//ڂ̃CfbNX擾
// idx w(-1)̏ꍇ́AI𒆂̍
//---------------------------------------------------------------------------
int __fastcall TClipBdList::GetHistListIndex(int idx)
{
	if (idx==-1) idx = HistListBox->ItemIndex;
	if (idx!=-1) {
		idx = (int)HistListBox->Items->Objects[idx];
		if (idx>=ClipHistList->Count) idx = -1;
	}
	return idx;
}
//---------------------------------------------------------------------------
//ڂ̕擾
// idx w(-1)̏ꍇ́AI𒆂̍
//---------------------------------------------------------------------------
UnicodeString __fastcall TClipBdList::GetListStr(int idx)
{
	UnicodeString retstr = EmptyStr;
	//
	if (PageControl1->ActivePage==ClipSheet) {
		idx = GetHistListIndex(idx);
		if (idx!=-1) retstr = ClipHistList->Items[idx]->Text;
	}
	//^
	else {
		if (TextListBox->Enabled) {
			if (idx==-1) idx = TextListBox->ItemIndex;
			if (idx!=-1) {
				retstr = TextListBox->Items->Strings[idx];
				if (retstr=="-") {
					retstr = EmptyStr;
				}
				else {
					if (retstr.Pos("\t")>0) retstr = Trim(get_tkn_r(retstr, "\t"));
					retstr = exp_FormatStr(retstr);
				}
			}
		}
	}
	return retstr;
}

//---------------------------------------------------------------------------
//݂̒^t@Cۑ
//---------------------------------------------------------------------------
bool __fastcall TClipBdList::SaveTextList()
{
	bool ret = false;
	Screen->Cursor = crHourGlass;
	try {
		TextListBox->Items->SaveToFile(TextDataFile);
		ret = true;
	}
	__finally {
		Screen->Cursor = crDefault;
	}
	return ret;
}

//---------------------------------------------------------------------------
//Xg: \XV
//---------------------------------------------------------------------------
void __fastcall TClipBdList::UpdateHistList(int idx, UnicodeString kwd)
{
	HistListBox->Clear();
	if (kwd.IsEmpty()) {
		for (int i=0; i<ClipHistList->Count; i++) {
			HistListBox->Items->AddObject(ClipHistList->Items[i]->ItemStr, (TObject*)i);
		}
	}
	else {
		//Migemo
		if (MigemoCheckBox->Checked) {
			UnicodeString ptn = usr_Migemo->GetRegExPtn(true, kwd);
			TRegExOptions opt; opt << roIgnoreCase;
			if (!ptn.IsEmpty()) {
				for (int i=0; i<ClipHistList->Count; i++) {
					UnicodeString lbuf = ClipHistList->Items[i]->ItemStr;
					if (TRegEx::IsMatch(lbuf, ptn, opt))
						HistListBox->Items->AddObject(lbuf, (TObject*)i);
				}
			}
		}
		//ʏ
		else {
			kwd = kwd.UpperCase();
			for (int i=0; i<ClipHistList->Count; i++) {
				UnicodeString lbuf = ClipHistList->Items[i]->ItemStr;
				if (lbuf.UpperCase().Pos(kwd))
					HistListBox->Items->AddObject(lbuf, (TObject*)i);
			}
		}
	}

	if (idx>=HistListBox->Count) idx = HistListBox->Count - 1;
	HistListBox->ItemIndex = idx;
}
//---------------------------------------------------------------------------
//Nbv{[h痚֒ǉ
//---------------------------------------------------------------------------
bool __fastcall TClipBdList::AddHistList(bool force)
{
	bool ret = true;
	try {
		if (!ClipEnabled && !force) Abort();

		UnicodeString cbuf;
		Clipboard()->Open();
		if (Clipboard()->HasFormat(CF_TEXT)) {
			HGLOBAL hCbTxt = (HGLOBAL)Clipboard()->GetAsHandle(CF_TEXT);
		    try {
				cbuf = Clipboard()->AsText;
			}
			__finally {
				::GlobalUnlock(hCbTxt);
			}
		}
		Clipboard()->Close();

		if (cbuf.IsEmpty()) Abort();
		if (MaxTextLen>0 && cbuf.Length()>MaxTextLen)    Abort();
		if (MaxLineCnt>0 && count_lins(cbuf)>MaxLineCnt) Abort();

		if (ClipHistList->Count>0) {
			if (CompareStr(ClipHistList->Items[0]->Text, cbuf)==0) Abort();
		}

		//O
		for (int i=0; i<ExceptWordList->Count; i++) {
			UnicodeString wd = ExceptWordList->Strings[i];
			bool re_sw = false;
			if (wd.Length()>2) re_sw = (wd[1]=='/' && wd[wd.Length()]=='/');
			//K\
			if (re_sw) {
				wd.Delete(wd.Length(),1);
				wd.Delete(1, 1);
				TRegExOptions opt;  opt << roIgnoreCase;
				if (TRegEx::IsMatch(cbuf, wd, opt)) Abort();
			}
			//ʏ핶
			else {
				if (ContainsText(cbuf, wd)) Abort();
			}
		}

		//^ɂ̂O
		for (int i=0; i<TextListBox->Count; i++) {
			UnicodeString tbuf = TextListBox->Items->Strings[i];
			if (tbuf=="-") continue;
			if (tbuf.Pos("\t")>0) tbuf = Trim(get_tkn_r(tbuf, "\t"));
			tbuf = exp_FormatStr(tbuf);
			if (CompareStr(Trim(tbuf), Trim(cbuf))==0) Abort();
		}

		HistoryRec *hp = new HistoryRec(cbuf);
		ClipHistList->Insert(0, hp);

		//ȑȌdf[^폜
		int idx = 1;
		while (idx<ClipHistList->Count) {
			if (CompareStr(ClipHistList->Items[idx]->Text, cbuf)==0) {
				delete ClipHistList->Items[idx];
				ClipHistList->Delete(idx);
			}
			else {
				idx++;
			}
		}
		//ő區ڐŐ
		while (ClipHistList->Count>MaxCbItems) {
			delete ClipHistList->Items[MaxCbItems];
			ClipHistList->Delete(MaxCbItems);
		}
		UpdateHistList();
	}
	catch(...) {
		ret = false;
	}
	return ret;
}
//---------------------------------------------------------------------------
//Nbv{[ht@Cɕۑ
//---------------------------------------------------------------------------
void __fastcall TClipBdList::SaveHistList()
{
	if (SaveHistory) ClipHistList->SaveToFile(ClipDataFile);
}

//---------------------------------------------------------------------------
void __fastcall TClipBdList::PageControl1Change(TObject *Sender)
{
	if (PageControl1->ActivePage==ClipSheet) {
		HistListBox->SetFocus();
		HistListBoxClick(NULL);
	}
	else {
		if (TextListBox->Enabled) TextListBox->SetFocus();
		TextListBoxClick(NULL);
	}
}

//---------------------------------------------------------------------------
//Xgڂ̕`
//---------------------------------------------------------------------------
void __fastcall TClipBdList::DrawListItem(UnicodeString s, TCanvas *cv, int xp, int yp, int x_max, bool is_hist)
{
	UnicodeString tb_str = is_hist? "\t" : "\\t";
	UnicodeString cr_str = is_hist? "\n" : "\\n";

	for (;;) {
		int p_tb = s.Pos(tb_str);
		int p_cr = s.Pos(cr_str);
		int cp = (p_tb==0)? p_cr : (p_cr==0)? p_tb : std::min(p_tb, p_cr);
		if (cp>0) {
			UnicodeString tmpstr = s.SubString(1, cp - 1);
			s.Delete(1, cp + (is_hist? 0 : 1));
			cv->TextOut(xp, yp, tmpstr);	xp += cv->TextWidth(tmpstr);
			TColor orgcol = cv->Font->Color;
			cv->Font->Color = colCtrl;
			tmpstr = (cp==p_tb)? _T(" \u21c0") : _T("\u21b4");
			cv->TextOut(xp, yp, tmpstr);	xp += (cv->TextWidth(tmpstr));
			cv->Font->Color = orgcol;
			if (s.IsEmpty()) break;
			if (xp > x_max)  break;
		}
		else {
			cv->TextOut(xp, yp, s);
			break;
		}
	}
}

//---------------------------------------------------------------------------
//Xg: ڂ̕`
//---------------------------------------------------------------------------
void __fastcall TClipBdList::HistListBoxDrawItem(TWinControl *Control,
      int Index, TRect &Rect, TOwnerDrawState State)
{
	TListBox *lp = (TListBox *)Control;
	TCanvas  *cv = lp->Canvas;
	cv->Brush->Color = State.Contains(odSelected)? colSelBg : lp->Color;
	cv->FillRect(Rect);

	int fh = abs(cv->Font->Height);
	int yp = Rect.Top;
	//fBOȂΏ
	if (cv->TextHeight("Q")<=fh) yp += (lp->ItemHeight - fh)/2;
	int xp = Rect.Left + 4;

	//s\
	if (ShowLnCt) {
		int idx  = GetHistListIndex(Index);
		int lcnt = (idx!=-1)? ClipHistList->Items[idx]->LineCount : 1;
		TColor orgcol = cv->Font->Color;
		cv->Font->Color = colLnCt;
		UnicodeString lcnt_str = UnicodeString().sprintf(_T("%3u"), lcnt);
		cv->TextOut(xp, yp, lcnt_str);
		cv->Font->Color = orgcol;
		xp += (cv->TextWidth(lcnt_str) + 4);
		cv->Pen->Color = colLnCt;
		cv->Pen->Style = psSolid;
		cv->MoveTo(xp, Rect.Top);
		cv->LineTo(xp, Rect.Bottom);
		xp += 6;
	}

	//e\
	DrawListItem(lp->Items->Strings[Index], cv, xp, yp, Rect.Right, true);
}

//---------------------------------------------------------------------------
//Xg: L[
//---------------------------------------------------------------------------
void __fastcall TClipBdList::HistListBoxKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
	TListBox *lp = HistListBox;

	switch (Key) {
	case VK_RETURN:
		PasteAction->Execute();
		break;
	case VK_DELETE:
		DelItemAction->Execute();
		break;
	case VK_ESCAPE:
		Hide();
		break;

	case VK_UP:
		if (lp->ItemIndex==0) {
			lp->ItemIndex = lp->Count - 1;
			Key = 0;
		}
		break;
	case VK_DOWN:
		if (lp->ItemIndex==lp->Count - 1) {
			lp->ItemIndex = 0;
			Key = 0;
		}
		break;
	}
}
//---------------------------------------------------------------------------
//Xg: }EX
//---------------------------------------------------------------------------
void __fastcall TClipBdList::HistListBoxClick(TObject *Sender)
{
	TListBox *lp = HistListBox;
	int idx = GetHistListIndex();
	if (idx!=-1) {
		UnicodeString tmpstr = UnicodeString().sprintf(_T("%3u/%3u"), lp->ItemIndex + 1, lp->Count);
		if (lp->Count != ClipHistList->Count) tmpstr.cat_sprintf(_T("(%u)"), ClipHistList->Count);
		StatusBar1->Panels->Items[0]->Text = tmpstr;
		HistoryRec *hp = ClipHistList->Items[idx];
		tmpstr.sprintf(_T("%8u/ %5us"), hp->Text.Length(), hp->LineCount);
		tmpstr += FormatDateTime("    yy/mm/dd hh:nn:ss",  hp->CreTime);
		StatusBar1->Panels->Items[1]->Text = tmpstr;

		if (PreviewLn>0 && hp->LineCount>=PreviewLn) {
			PreviewMemo->Lines->Text = hp->Text;
			if (!PreviewMemo->Visible) {
				::SendMessage(ClipSheet->Handle, WM_SETREDRAW, 0, 0);
				{
					PreviewMemo->Visible = true;
					Splitter1->Align	 = alTop;
					PreviewMemo->Align	 = alBottom;
					Splitter1->Align	 = alBottom;
				}
				::SendMessage(ClipSheet->Handle, WM_SETREDRAW, 1, 0);

				for (int i=0; i<ClipSheet->ControlCount; i++) {
					TControl *cp = ClipSheet->Controls[i];
					if (cp->Visible) cp->Invalidate();
				}

				//̈OɂȂXN[
				int pn = lp->ClientHeight/lp->ItemHeight;
				if (lp->ItemIndex > lp->TopIndex + pn - 1)
					lp->TopIndex = std::max(lp->ItemIndex - pn + 1, 0);
			}
		}
		else {
			PreviewMemo->Visible = false;
		}
	}
	else {
		StatusBar1->Panels->Items[0]->Text
			= UnicodeString().sprintf(_T("-/%u(%u)"), lp->Count, ClipHistList->Count);
		StatusBar1->Panels->Items[1]->Text = EmptyStr;
	}
}

//---------------------------------------------------------------------------
//\t
//---------------------------------------------------------------------------
void __fastcall TClipBdList::PasteActionExecute(TObject *Sender)
{
	UnicodeString tmpstr = GetListStr();
	if (!tmpstr.IsEmpty()) {
		Clipboard()->AsText = tmpstr;
		DWORD cur_tid = ::GetCurrentThreadId();
		if (::AttachThreadInput(cur_tid, LastThreadID, TRUE)) {
			::SetForegroundWindow(hLastWnd);
			::SetFocus(hLastFocus);
			//WM_PASTE œ\t
			if (HotQMainForm->PasteClassList->IndexOf(get_ClassName(hLastFocus))!=-1) {
				::SendMessage(hLastFocus, WM_PASTE, 0, 0);
			}
			//Ctrl + V œ\t
			else {
				Sleep(50);
				::keybd_event(VK_CONTROL, 0, 0, 0);
				::keybd_event('V', 0, 0, 0);
				Sleep(100);
				::keybd_event('V', 0, KEYEVENTF_KEYUP, 0);
				::keybd_event(VK_CONTROL, 0, KEYEVENTF_KEYUP, 0);
				Application->ProcessMessages();
			}
			::AttachThreadInput(cur_tid, LastThreadID, FALSE);
		}
	}

	Hide();
}

//---------------------------------------------------------------------------
//Nbv{[hɓ
//---------------------------------------------------------------------------
void __fastcall TClipBdList::CopyClipActionExecute(TObject *Sender)
{
	Clipboard()->AsText = GetListStr();
	Hide();
}
//---------------------------------------------------------------------------
void __fastcall TClipBdList::SelItemUpdate(TObject *Sender)
{
	if (PageControl1->ActivePage==ClipSheet)
		((TAction *)Sender)->Enabled = !GetListStr().IsEmpty();
	else
		((TAction *)Sender)->Enabled = !GetListStr().IsEmpty() && !ItemEditPanel->Visible;
}

//---------------------------------------------------------------------------
//^ɒǉo^
//---------------------------------------------------------------------------
void __fastcall TClipBdList::RegToTextActionExecute(TObject *Sender)
{
	RegTextList(GetListStr());
}
//---------------------------------------------------------------------------
void __fastcall TClipBdList::RegToTextActionUpdate(TObject *Sender)
{
	((TAction *)Sender)->Enabled = !GetListStr().IsEmpty();
}

//---------------------------------------------------------------------------
//Xg: sɓWJ
//---------------------------------------------------------------------------
void __fastcall TClipBdList::ExLineActionExecute(TObject *Sender)
{
	int idx = GetHistListIndex();	if (idx==-1) return;
	UnicodeString sbuf = ClipHistList->Items[idx]->Text;
	TDateTime  tm = ClipHistList->Items[idx]->CreTime;
	delete ClipHistList->Items[idx];
	ClipHistList->Delete(idx);
	sbuf = ReplaceStr(sbuf,"\r\n", "\n");
	sbuf = ReplaceStr(sbuf,"\r", "\n");
	int ixp = idx;
	while (!sbuf.IsEmpty() && ixp<MaxCbItems) {
		int p = sbuf.Pos("\n");
		if (p==0) {
			if (!sbuf.IsEmpty()) {
				HistoryRec *hp = new HistoryRec(sbuf);
				hp->CreTime = tm;
				ClipHistList->Insert(ixp++, hp);
			}
			sbuf = EmptyStr;
		}
		else {
			UnicodeString tmpstr = sbuf.SubString(1, p - 1);
			if (!tmpstr.IsEmpty()) {
				HistoryRec *hp = new HistoryRec(tmpstr);
				hp->CreTime = tm;
				ClipHistList->Insert(ixp++, hp);
			}
			sbuf.Delete(1, p);
		}
		tm -= 0.0000001157;	// тȂ悤 -1/100sec
	}

	while (ClipHistList->Count>MaxCbItems) {
		delete ClipHistList->Items[MaxCbItems];
		ClipHistList->Delete(MaxCbItems);
	}
	UpdateHistList(idx);
}
//---------------------------------------------------------------------------
void __fastcall TClipBdList::ExLineActionUpdate(TObject *Sender)
{
	int idx = HistListBox->ItemIndex;
	((TAction *)Sender)->Enabled = (idx!=-1)? (ClipHistList->Items[idx]->LineCount>1) : false;
}

//---------------------------------------------------------------------------
//ڂ폜
//---------------------------------------------------------------------------
void __fastcall TClipBdList::DelItemActionExecute(TObject *Sender)
{
	if (PageControl1->ActivePage==ClipSheet) {
		TListBox *lp = HistListBox;
		if (lp->ItemIndex==-1) return;
		int idx = GetHistListIndex();	if (idx==-1) return;

		delete ClipHistList->Items[idx];
		ClipHistList->Delete(idx);

		int itm_idx = lp->ItemIndex;
		lp->Items->Delete(itm_idx);

		for (int i=itm_idx; i<lp->Count; i++) {
			int n = (int)lp->Items->Objects[i];
			if (n>idx) {
				n--;
				lp->Items->Objects[i] = (TObject*)n;
			}
		}

		if (itm_idx>=lp->Count) itm_idx = lp->Count - 1;
		lp->ItemIndex = itm_idx;
		HistListBoxClick(NULL);
	}
	else {
		TListBox *lp = TextListBox;
		int idx = lp->ItemIndex;
		if (idx!=-1) lp->Items->Delete(idx);
		if (idx>=lp->Count) idx = lp->Count - 1;
		lp->ItemIndex = idx;
		TextListBoxClick(NULL);
		SaveTextList();
	}
}
//---------------------------------------------------------------------------
void __fastcall TClipBdList::DelItemActionUpdate(TObject *Sender)
{
	if (PageControl1->ActivePage==ClipSheet)
		((TAction *)Sender)->Enabled = !GetListStr().IsEmpty();
	else
		((TAction *)Sender)->Enabled = (TextListBox->ItemIndex!=-1 && !ItemEditPanel->Visible);
}

//---------------------------------------------------------------------------
//Xg̑Sڂ폜
//---------------------------------------------------------------------------
void __fastcall TClipBdList::AllDelActionExecute(TObject *Sender)
{
	//S
	if (HistListBox->Count == ClipHistList->Count) {
		for (int i=0; i<ClipHistList->Count; i++) delete ClipHistList->Items[i];
		ClipHistList->Clear();
		HistListBox->Clear();
	}
	//i荞ݒ
	else {
		for (int i=0; i<HistListBox->Count; i++) {
			int idx = (int)HistListBox->Items->Objects[i];
			idx -= i;
			if (idx>=0 && idx<ClipHistList->Count) {
				delete ClipHistList->Items[idx];
				ClipHistList->Delete(idx);
			}
		}
	}
	UpdateHistList();
}
//---------------------------------------------------------------------------
void __fastcall TClipBdList::AllDelActionUpdate(TObject *Sender)
{
	((TAction *)Sender)->Enabled = (HistListBox->Count>0);
}

//---------------------------------------------------------------------------
//Xg: \[g
//---------------------------------------------------------------------------
void __fastcall TClipBdList::SortTextActionExecute(TObject *Sender)
{
	ClipHistList->Sort(HistCmp_Text);
	UpdateHistList();
}
//---------------------------------------------------------------------------
void __fastcall TClipBdList::SortTimeActionExecute(TObject *Sender)
{
	ClipHistList->Sort(HistCmp_Time);
	UpdateHistList();
}
//---------------------------------------------------------------------------
void __fastcall TClipBdList::SortLengthActionExecute(TObject *Sender)
{
	ClipHistList->Sort(HistCmp_Length);
	UpdateHistList();
}
//---------------------------------------------------------------------------
void __fastcall TClipBdList::SortLineCntActionExecute(TObject *Sender)
{
	ClipHistList->Sort(HistCmp_LineCnt);
	UpdateHistList();
}
//---------------------------------------------------------------------------
void __fastcall TClipBdList::SortActionUpdate(TObject *Sender)
{
	((TAction *)Sender)->Enabled = (ClipHistList->Count>1);
}

//---------------------------------------------------------------------------
void __fastcall TClipBdList::FindComboBoxChange(TObject *Sender)
{
	UpdateHistList(0, FindComboBox->Text);
}
//---------------------------------------------------------------------------
void __fastcall TClipBdList::MigemoCheckBoxClick(TObject *Sender)
{
	if (!FindComboBox->Text.IsEmpty()) FindComboBoxChange(NULL);
}

//---------------------------------------------------------------------------
//tB^ł̃L[
//---------------------------------------------------------------------------
void __fastcall TClipBdList::FindComboBoxKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
	TListBox *lp = HistListBox;

	switch (Key) {
	case VK_RETURN:
		PasteAction->Execute();
		//tB^ǉ
		if (!FindComboBox->Text.IsEmpty()) add_ComboBox_history(FindComboBox);
		break;
	case VK_ESCAPE:
		Hide();
		break;

	case VK_UP:
		if (lp->ItemIndex>0) lp->ItemIndex = lp->ItemIndex - 1;
		Key = 0;
		break;
	case VK_DOWN:
		if (lp->ItemIndex<(lp->Count - 1)) lp->ItemIndex = lp->ItemIndex + 1;
		Key = 0;
		break;
	}
}
//---------------------------------------------------------------------------
void __fastcall TClipBdList::FindComboBoxKeyPress(TObject *Sender, System::WideChar &Key)
{
	if (Key==VK_ESCAPE || Key==VK_RETURN) Key = 0;
}

//---------------------------------------------------------------------------
//ƂȂ
//---------------------------------------------------------------------------
void __fastcall TClipBdList::StopActionExecute(TObject *Sender)
{
	ClipEnabled = !ClipEnabled;
	UnicodeString tmpstr = "Nbv{[h";
	if (!ClipEnabled) tmpstr += "  (~)";
	Caption = tmpstr;
}
//---------------------------------------------------------------------------
void __fastcall TClipBdList::StopActionUpdate(TObject *Sender)
{
	((TAction *)Sender)->Checked = !ClipEnabled;
}

//---------------------------------------------------------------------------
//ɖOtĂɕۑ
//---------------------------------------------------------------------------
void __fastcall TClipBdList::SaveHistActionExecute(TObject *Sender)
{
	SaveDialog1->Title		= "ɖOtĕۑ";
	SaveDialog1->Filter 	= "f[^t@C (*.txt)|*.TXT";
	SaveDialog1->DefaultExt = "TXT";
	SaveDialog1->FileName	= "*.txt";
	SaveDialog1->InitialDir	= ExtractFileDir(ClipDataFile);
	if (SaveDialog1->Execute()) {
		ClipHistList->SaveToFile(SaveDialog1->FileName);
	}
}
//---------------------------------------------------------------------------
void __fastcall TClipBdList::SaveHistActionUpdate(TObject *Sender)
{
	((TAction *)Sender)->Enabled = (ClipHistList->Count>0);
}
//---------------------------------------------------------------------------
//t@CǍ
//---------------------------------------------------------------------------
void __fastcall TClipBdList::LoadHistActionExecute(TObject *Sender)
{
	OpenDialog1->Title		= "t@CǍ";
	OpenDialog1->Filter 	= "f[^t@C (*.txt)|*.TXT";
	OpenDialog1->DefaultExt = "TXT";
	OpenDialog1->FileName	= "*.txt";
	OpenDialog1->InitialDir	= ExtractFileDir(ClipDataFile);
	if (OpenDialog1->Execute()) {
		ClipHistList->LoadFromFile(OpenDialog1->FileName);
		UpdateHistList();
	}
}

//---------------------------------------------------------------------------
//^Xg: ڂ̕`
//---------------------------------------------------------------------------
void __fastcall TClipBdList::TextListBoxDrawItem(TWinControl *Control, int Index,
          TRect &Rect, TOwnerDrawState State)
{
	TListBox *lp = (TListBox *)Control;
	TCanvas  *cv = lp->Canvas;
	cv->Brush->Color = State.Contains(odSelected)? colSelBg : lp->Color;
	cv->FillRect(Rect);

	UnicodeString itmstr = get_tkn(lp->Items->Strings[Index], "\t");
	int fh = abs(cv->Font->Height);
	int yp = Rect.Top;
	//fBOȂΏ
	if (cv->TextHeight("Q")<=fh) yp += (lp->ItemHeight - fh)/2;
	int xp = Rect.Left + 4;

	if (itmstr=="-") {
		TRect rc = Rect; rc.Top += fh/2;
		::DrawEdge(cv->Handle, &rc, EDGE_ETCHED, BF_TOP);
	}
	else {
		DrawListItem(itmstr, cv, xp, yp, Rect.Right, false);
	}
}

//---------------------------------------------------------------------------
//^Xg: hbO&hbvɂ鍀ڂ̈ړ
//---------------------------------------------------------------------------
void __fastcall TClipBdList::TextListBoxStartDrag(TObject *Sender, TDragObject *&DragObject)
{
	PrevListIdx = -1;
}
//---------------------------------------------------------------------------
void __fastcall TClipBdList::TextListBoxDragOver(TObject *Sender, TObject *Source,
          int X, int Y, TDragState State, bool &Accept)
{
	TListBox *lp = (TListBox *)Sender;
	Accept = (Source==Sender && lp->ItemIndex!=-1);		if (!Accept) return;

	int idx = lp->ItemAtPos(Point(X, Y), true);
	draw_ListItemLine(lp, PrevListIdx);		//Õhbv\
	draw_ListItemLine(lp, idx);				//Vhbv\`

	PrevListIdx = idx;
}
//---------------------------------------------------------------------------
void __fastcall TClipBdList::TextListBoxDragDrop(TObject *Sender, TObject *Source,
          int X, int Y)
{
	TListBox *lp = (TListBox *)Sender;
	int idx = lp->ItemAtPos(Point(X, Y), true);

	draw_ListItemLine(lp, PrevListIdx);		//Õhbv\

	if (idx!=-1) {
		lp->Items->Move(lp->ItemIndex, idx);
		SaveTextList();
	}
}

//---------------------------------------------------------------------------
void __fastcall TClipBdList::TextListBoxClick(TObject *Sender)
{
	TListBox *lp = TextListBox;
	StatusBar1->Panels->Items[0]->Text =
		(lp->ItemIndex!=-1)? UnicodeString().sprintf(_T("%3u/%3u"), lp->ItemIndex + 1, lp->Count) : EmptyStr;

	UnicodeString itmstr = GetListStr();
	itmstr = ReplaceStr(itmstr,"\r\n", "\\n");
	itmstr = ReplaceStr(itmstr,"\t", "\\t");
	StatusBar1->Panels->Items[1]->Text = itmstr;
}
//---------------------------------------------------------------------------
//^Xg: L[
//---------------------------------------------------------------------------
void __fastcall TClipBdList::TextListBoxKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
	TListBox *lp = (TListBox *)Sender;

	switch (Key) {
	case VK_RETURN:  PasteAction->Execute();   break;
	case VK_DELETE:  DelItemAction->Execute(); break;
	case VK_ESCAPE:  Hide(); break;

	case VK_UP:
		if (lp->ItemIndex==0) {
			lp->ItemIndex = lp->Count - 1;
			Key = 0;
		}
		break;
	case VK_DOWN:
		if (lp->ItemIndex==lp->Count - 1) {
			lp->ItemIndex = 0;
			Key = 0;
		}
		break;
	}
}

//---------------------------------------------------------------------------
//^̒ǉo^
//---------------------------------------------------------------------------
void __fastcall TClipBdList::RegTextList(UnicodeString s, int idx)
{
	if (s.IsEmpty()) return;
	s = ReplaceStr(s, "\r\n", "\\n");
	s = ReplaceStr(s, "\r", "\\n");
	s = ReplaceStr(s, "\t", "\\t");
	if (TextListBox->Items->IndexOf(s)==-1) {
		if (idx>=0 && idx<TextListBox->Count)
			TextListBox->Items->Insert(idx, s);
		else
			TextListBox->Items->Add(s);
		SaveTextList();
	}
	else {
		Application->MessageBox(_T("łɓo^Ă܂"), _T("x"), MB_OK|MB_ICONWARNING);
	}
}

//---------------------------------------------------------------------------
//Nbv{[hǉo^
//---------------------------------------------------------------------------
void __fastcall TClipBdList::RegFromClipActionExecute(TObject *Sender)
{
	RegTextList(Clipboard()->AsText);
}
//---------------------------------------------------------------------------
void __fastcall TClipBdList::RegFromClipActionUpdate(TObject *Sender)
{
	((TAction *)Sender)->Enabled = !Clipboard()->AsText.IsEmpty() && !ItemEditPanel->Visible;
}
//---------------------------------------------------------------------------
//Nbv{[h}
//---------------------------------------------------------------------------
void __fastcall TClipBdList::InsFromClipActionExecute(TObject *Sender)
{
	RegTextList(Clipboard()->AsText, TextListBox->ItemIndex);
}
//---------------------------------------------------------------------------
void __fastcall TClipBdList::InsFromClipActionUpdate(TObject *Sender)
{
	((TAction *)Sender)->Enabled
		= (!Clipboard()->AsText.IsEmpty() && !ItemEditPanel->Visible && TextListBox->ItemIndex!=-1);
}
//---------------------------------------------------------------------------
//Zp[^}
//---------------------------------------------------------------------------
void __fastcall TClipBdList::InsSepItemClick(TObject *Sender)
{
	int idx = TextListBox->ItemIndex;
	if (idx!=-1)
		TextListBox->Items->Insert(idx, "-");
	else
		TextListBox->Items->Add("-");
	SaveTextList();
}

//---------------------------------------------------------------------------
//^̒`t@CҏW
//---------------------------------------------------------------------------
void __fastcall TClipBdList::EditTextDataActionExecute(TObject *Sender)
{
	HotQMainForm->EditFile(TextDataFile);

	if (Application->MessageBox(
		_T("^̒`t@Cēǂݍ݂܂"), _T("mF"), MB_YESNO|MB_ICONQUESTION) == IDYES)
			ReloadTextDataAction->Execute();

	Hide();
}
//---------------------------------------------------------------------------
void __fastcall TClipBdList::EditTextDataActionUpdate(TObject *Sender)
{
	((TAction *)Sender)->Enabled
		= !HotQMainForm->IniEditor.IsEmpty() && FileExists(TextDataFile) && !ItemEditPanel->Visible;
}
//---------------------------------------------------------------------------
//^̒`t@Cēǂݍ
//---------------------------------------------------------------------------
void __fastcall TClipBdList::ReloadTextDataActionExecute(TObject *Sender)
{
	TextListBox->Items->LoadFromFile(TextDataFile);
	if (TextListBox->Count>0) TextListBox->ItemIndex = 0;
	TextListBoxClick(NULL);
}
//---------------------------------------------------------------------------
void __fastcall TClipBdList::ReloadTextDataActionUpdate(TObject *Sender)
{
	((TAction *)Sender)->Enabled = FileExists(TextDataFile) && !ItemEditPanel->Visible;
}

//---------------------------------------------------------------------------
//^̍ڂҏW
//---------------------------------------------------------------------------
void __fastcall TClipBdList::EditTextItemActionExecute(TObject *Sender)
{
	int idx = TextListBox->ItemIndex;
	if (idx!=-1) {
		UnicodeString itmstr = TextListBox->Items->Strings[idx];
		if (itmstr.Pos("\t")>0) {
			ItemLabelEdit->Text = Trim(get_tkn(itmstr, "\t"));
			itmstr = get_tkn_r(itmstr, "\t");
		}
		else {
			ItemLabelEdit->Text = EmptyStr;
		}

		itmstr = ReplaceStr(itmstr, "\\n", "\r\n");
		itmstr = ReplaceStr(itmstr, "\\t", "\t");
		ItemMemo->Text = itmstr;

		ItemEditPanel->Visible = true;
		ItemMemo->SetFocus();
		TextDataBar->Enabled   = false;
		TextListBox->Enabled   = false;
	}
}
//---------------------------------------------------------------------------
void __fastcall TClipBdList::EditTextItemActionUpdate(TObject *Sender)
{
	((TAction *)Sender)->Enabled = !GetListStr().IsEmpty() && !ItemEditPanel->Visible;
}

//---------------------------------------------------------------------------
//ҏWm
//---------------------------------------------------------------------------
void __fastcall TClipBdList::EditOkBtnClick(TObject *Sender)
{
	int idx = TextListBox->ItemIndex;
	if (idx!=-1) {
		UnicodeString itmstr = ItemMemo->Text;
		itmstr = ReplaceStr(itmstr, "\r\n", "\\n");
		itmstr = ReplaceStr(itmstr, "\t",   "\\t");
		if (!ItemLabelEdit->Text.IsEmpty())
			itmstr = ItemLabelEdit->Text + "\t" + itmstr;
		TextListBox->Items->Strings[idx] = itmstr;
		SaveTextList();
	}

	ItemEditPanel->Visible = false;
	TextDataBar->Enabled   = true;
	TextListBox->Enabled   = true;
	TextListBox->SetFocus();
}

//---------------------------------------------------------------------------
//ҏWf
//---------------------------------------------------------------------------
void __fastcall TClipBdList::EditCanBtnClick(TObject *Sender)
{
	ItemEditPanel->Visible = false;
	TextDataBar->Enabled   = true;
	TextListBox->Enabled   = true;
	TextListBox->SetFocus();
}
//---------------------------------------------------------------------------
//̎Q
//---------------------------------------------------------------------------
void __fastcall TClipBdList::Ref_ItemClick(TObject *Sender)
{
	TMenuItem *mp = (TMenuItem *)Sender;
	UnicodeString s = mp->Caption;
	Clipboard()->AsText = get_tkn(mp->Caption, " ");
	if (ItemLabelEdit->Focused())
		ItemLabelEdit->PasteFromClipboard();
	else if (ItemMemo->Focused())
		ItemMemo->PasteFromClipboard();
}

//---------------------------------------------------------------------------
//^t@CI{^
//---------------------------------------------------------------------------
bool __fastcall TClipBdList::ChangeTextData(int idx)
{
	bool ret = false;
	if (idx>=0 && idx<MAX_TEXTDATABTN) {
		if (FileExists(TextBtnFile[idx])) {
			TextDataFile = TextBtnFile[idx];
			TextListBox->Items->LoadFromFile(TextDataFile);
			if (TextListBox->Count>0) TextListBox->ItemIndex = 0;
			TextListBoxClick(NULL);
			IniFile->WriteString("ClipboardList", "TextDataFile",	TextDataFile);
			ret = true;
			TextDataBar->Buttons[idx]->Down = true;
		}
	}
	return ret;
}
//---------------------------------------------------------------------------
void __fastcall TClipBdList::TextDataBtnClick(TObject *Sender)
{
	ChangeTextData(((TComponent *)Sender)->Tag);
}
//---------------------------------------------------------------------------

