//----------------------------------------------------------------------//
// MIGEMO																//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <tchar.h>
#include <System.StrUtils.hpp>
#include <System.IOUtils.hpp>
#include <RegularExpressions.hpp>
#include "usr_migemo.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)

//---------------------------------------------------------------------------
MigemoUnit  *usr_Migemo = NULL;

//---------------------------------------------------------------------------
MigemoUnit::MigemoUnit(UnicodeString dnam)
{
	Available = false;
	DictReady = false;
	MigemoObj = NULL;

	PathName  = IncludeTrailingPathDelimiter(dnam);
	if (PathName.IsEmpty())
		PathName = ExtractFilePath(Application->ExeName);
	else
		PathName = IncludeTrailingPathDelimiter(PathName);

	DllName = PathName + "migemo.dll";
	hMigemo = ::LoadLibrary(DllName.c_str());
	if (hMigemo) {
		f_migemo_open	 = (FUNC_migemo_open)::GetProcAddress(hMigemo,		"migemo_open");
		f_migemo_close	 = (FUNC_migemo_close)::GetProcAddress(hMigemo,		"migemo_close");
		f_migemo_query	 = (FUNC_migemo_query)::GetProcAddress(hMigemo,		"migemo_query");
		f_migemo_release = (FUNC_migemo_release)::GetProcAddress(hMigemo,	"migemo_release");
		Available = f_migemo_open && f_migemo_close && f_migemo_query && f_migemo_release;

		if (Available) {
			//
			TSearchOption opt = TSearchOption::soAllDirectories;
			TStringDynArray f_list = TDirectory::GetFiles(PathName, "migemo-dict", opt);
			UnicodeString dic_name;
			for (int i=0; i<f_list.Length; ++i) {
				UnicodeString fnam = f_list[i].LowerCase();
				if (!ContainsText(fnam, "utf-8")) {
					dic_name = fnam; break;
				}
			}
			//ǂݍ
			if (!dic_name.IsEmpty()) {
				MigemoObj = f_migemo_open(AnsiString(dic_name).c_str());
				DictReady = (MigemoObj!=NULL);
			}
		}
	}
}

//---------------------------------------------------------------------------
MigemoUnit::~MigemoUnit()
{
	if (MigemoObj) f_migemo_close(MigemoObj);
	if (hMigemo) ::FreeLibrary(hMigemo);
}

//---------------------------------------------------------------------------
//T[`pK\擾
//---------------------------------------------------------------------------
UnicodeString MigemoUnit::Query(UnicodeString qstr)
{
	UnicodeString ret_str;
	if (MigemoObj) {
		unsigned char *qp = f_migemo_query(MigemoObj, AnsiString(qstr).c_str());
		if (qp) {
			ret_str = UnicodeString((char*)qp);
			f_migemo_release(MigemoObj, qp);
			//GXP[vĂȂ "+" ܂܂Ăꍇɑ΂Ώ
			ret_str = TRegEx::Replace(ret_str, "([^\\\\])\\+", "\\1\\\\+");
		}
	}
	return ret_str;
}

//---------------------------------------------------------------------------
//K\p^[擾
// sw: migemo 𗘗p
//---------------------------------------------------------------------------
UnicodeString MigemoUnit::GetRegExPtn(bool sw, UnicodeString w)
{
	if (w.IsEmpty()) return EmptyStr;

	UnicodeString ptn = sw? Query(w) : TRegEx::Escape(w);

	//K\p^[̃`FbN
	if (!ptn.IsEmpty()) {
		try {
			TRegEx x(ptn, TRegExOptions() << roCompiled);
		}
		catch (...) {
			ptn = EmptyStr;
		}
	}

	return ptn;
}
//---------------------------------------------------------------------------
